#define PRF_WHIRLPOOL 0
#define PRF_SHA3 1

#ifdef TEST_SHA256
#define PRF_SHA256 -1
void hmac_sha256(unsigned char *k, int lk, unsigned char *d, int ld, unsigned char *out);
#endif

void hmac_whirlpool(unsigned char *k, int lk, unsigned char *d, int ld, unsigned char *out);
void hmac_sha3(unsigned char *k, int lk, unsigned char *d, int ld, unsigned char *out);

int scrypt(int prf, unsigned char *passwd, unsigned int passwdlen, unsigned char *salt, unsigned int saltlen, unsigned long N, unsigned int r, unsigned int p, unsigned char *buf, unsigned int buflen);
// salt must be 4 byte free at its end, saltlen doesn't include these bytes