typedef unsigned long fullSbox[4][256];
typedef struct {
	unsigned long key[8], subkeys_dec[40], subkeys_enc[40];
	fullSbox sBox8x32;
} twofish_key;

void twofish_init(twofish_key *key);
void twofish_close(twofish_key *key);
void twofish_encrypt(twofish_key *key, unsigned char *buffer);
void twofish_decrypt(twofish_key *key, unsigned char *buffer);
